// Control code for the WEUR app

$(function() {

	//URL address change 
	$('#address').val( localStorage.getItem('address') );
	$('#address').change(function() {
		localStorage.setItem('address', $('#address').val() );
	});
	window.address = $('#address').val();
	//window.address = "192.168.1.177";
	
	window.option_flag = false;

	//load and display buttons
	$.get("get.php?req=http://" + address + "/a"  , function(res){
		//alert("f00: " + res);
		rowArr = res.split("|");
		for(var i = 0; i < rowArr.length -1; i++)
		{
			columnArr = rowArr[i].split(",");
			$('#content').prepend( '<div class="button" alt="' + columnArr[0] + '">' + columnArr[1] + '</div>' );
		}

		//Button action code
		$('.button').click(function() {
			//alert("button! " + $(this).attr('alt') );
			if(option_flag)
			{
				openModal( $(this) );				
			} else {
				playCode( $(this).attr('alt') );
			}
		});

	});
	
	$('#option').change( function() {
		if(option_flag)
		{
			option_flag = false;
			clearInterval(anim_interval);
			$(".button").stop (true);
			$(".button").css("backgroundColor", "white");
		} else {
			option_flag = true;
			window.anim_interval = setInterval( function() {
				$(".button").animate({backgroundColor:"red" }, 500 ).animate({backgroundColor:"white" }, 500 );
			}, 1000);
		}
	});

	var name = $( "#name" ),
		knock = $( "#knock" ),
		allFields = $( [] ).add( name ).add( email );
		
	$( "#dialog-form" ).dialog({
			autoOpen: false,
			height: 300,
			width: 350,
			modal: true,
			buttons: {
				"Create an account": function() {
					var bValid = true;
					allFields.removeClass( "ui-state-error" );

					bValid = bValid && checkLength( name, "username", 3, 16 );
					bValid = bValid && checkLength( knock, "knock", 6, 80 );

					if ( bValid ) {
						$( "#users tbody" ).append( "<tr>" +
							"<td>" + name.val() + "</td>" + 
							"<td>" + knock.val() + "</td>" + 
						"</tr>" ); 
						$( this ).dialog( "close" );
					}
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			},
			close: function() {
				allFields.val( "" ).removeClass( "ui-state-error" );
			}
		});

	// The color gradient for theme selection
	//Width of color gradient (color resolution?)
	window.color_grad_width = 300;
	// Get the canvas element.
	window.elem = document.getElementById('canvas');
	// Get the canvas 2d context.
	window.context = window.elem.getContext('2d');
	Element.prototype.getElementWidth = function() {
	   if (typeof this.clip !== "undefined") {
		  return this.clip.width;
	   } else {
		  if (this.style.pixelWidth) {
			 return this.style.pixelWidth;
		  } else {
			return this.offsetWidth;
		  }
	   }
	}
	// The hue spectrum used by HSV color picker charts.
	var color, hue = [
	[255,   0,   0 ], // 0, Red,       0°
	[255, 255,   0 ], // 1, Yellow,   60°
	[  0, 255,   0 ], // 2, Green,   120°
	[  0, 255, 255 ], // 3, Cyan,    180°
	[  0,   0, 255 ], // 4, Blue,    240°
	[255,   0, 255 ], // 5, Magenta, 300°
	[255,   0,   0]], // 6, Red,     360°
	// Create the linear gradient: sx, sy, dx, dy.
	// That's the start (x,y) coordinates, followed by the destination (x,y).
	gradient = context.createLinearGradient(0, 0, elem.width, 0);
	// Add the color stops.
	for (var i = 0; i <= 6; i++) {
	color = 'rgb(' + hue[i][0] + ', ' + hue[i][1] + ', ' + hue[i][2] + ')';
	gradient.addColorStop(i * 1/6, color);
	}
	// Use the gradient for the fillStyle.
	context.fillStyle = gradient;
	context.fillRect(5, 5, color_grad_width, 100);

});

function getColorX(x)
{
	response(1);
		
	var temp_c = document.getElementById('canvas');
	x1 = ((color_grad_width * x) / temp_c.getElementWidth());
	//alert("adjusted X:" + x1 + " / canvaswidth:" + temp_c.getElementWidth() + " / color_grad_width:" + color_grad_width);
	var Pixel = context.getImageData(x1, 10, 1, 1);
	
	var hexcol = colorToHex(Pixel.data[0], Pixel.data[1], Pixel.data[2]);
	//change color scheme!
	//alert( "#" + hexcol.toUpperCase() );
	
	document.body.style.backgroundColor = "#" + hexcol.toUpperCase();
	$.get("get.php?req=http://" + address + "/c" + hexcol.toUpperCase() , function(res){
		response(2);
	});
	//alert("Pixel 1: " + Pixel.data[0] + ", " + Pixel.data[1] + ", " + Pixel.data[2] + ", " + Pixel.data[3]);
}

function getOffsets(event, img)
{
	var relativeX = event.clientX - img.offsetLeft;
	var relativeY = event.clientY - img.offsetTop;
	//alert(relativeX + " " + relativeY);
	return relativeX;
}

function componentToHex(c) {
	var hex = c.toString(16);
	return hex.length == 1 ? "0" + hex : hex;
}
	
function colorToHex(r, g, b) {
	return componentToHex(r) + componentToHex(g) + componentToHex(b);
}

function playCode(recno)
{
	response(1);	
	//fill out empty places with zeros
	recno_string = recno.toString();
	rl = recno_string.length;
	for(p = rl; p <= 5; p++)
	{
		recno_string = "0" + recno_string;
	}
	
	//alert(recno_string);
	$.get("get.php?req=http://" + address + "/s" + recno_string , function(res){
		//alert(res);
		response(2);
	});
}

function response(phase)
{
	if(phase == 1)
	{
		$('.piece').stop().animate({
			borderLeftColor: '#2FFF00',
			borderRightColor: '#2FFF00'
		  }, 100, function() {
			// Animation complete.
		});
	} else if (phase == 2) {
		$('.piece').css("borderColor", "#FFF");
		$('.piece').stop().animate({
			borderLeftColor: '#333',
			borderRightColor: '#333'
		  }, 500, function() {
			// Animation complete.
		});
	}
}

function openModal( obj )
{
	$( "#dialog-form" ).dialog( "open" );
}